﻿/**
* 2次元ベジェ曲線分割
* test 2
* @author nutsu
*/

package {
	
	import flash.utils.getTimer;
	import flash.geom.Point;
	
	public class BezjeSegmentTest2 extends BezjeSegmentTest1{
		
		/**
		* コンストラクタ
		*/
		public function BezjeSegmentTest2(){
			super();
		}
		
		/**
		*	描画
		*/
		protected override function draw():void{
			
			drawCurve();
			
			var tmp:int = getTimer();
			//-------------------------------
			//長さ等分で分割
			
			var bezje:Bezje2D = new Bezje2D( new Point(handle_start.x, handle_start.y),
			                                 new Point(handle_end.x, handle_end.y),
			                                 new Point(handle_ctrl.x, handle_ctrl.y));
			
			//分割数
			var sn:Number = 10;
			//分割差分
			var dlen:Number  = bezje.length/sn;
			//tの精度
			var dt:Number    = 0.001;
			
			var tmp_len:Number = dlen;
			var tmp_n:int = 1;
			
			plots.graphics.clear();
			
			//trace( "delta>>>" , dlen );
			for( var t:Number=0; t<=1.0 ; t+=dt ){
				var len:Number = bezje.integral(t);
				if( len>=tmp_len ){
					//trace( Math.abs( len-tmp_len ) );
					plot( plots.graphics, bezje.f(t) );
					tmp_n++;
					if( tmp_n==sn ){
						break;
					}
					tmp_len = dlen*tmp_n;
				}
			}
			//--------------------------------
			trace( "time", getTimer()-tmp );
		}
	}
	
}

